/*
 activator.c
  for manual activation of the \177XDBTools extension (use is unrecommended)

  This was from scratch, and wasnt meant to use the precompiled
    headers... but that eventually got written in.

December 5, 2004 5:26 AM EDST
A.P.: Creation.
December 16, 2004 3:12 PM
  Updated for new format; $50FF8001 shouldve been $68F168F1.
3:18 PM
  Took out the XDBDispatch enum because the trap is not official, and...
    it just looks stupid.  Its worth the trouble replacing every occurence...
*/

#include <Folders.h>
#include <Resources.h>
#include <Patches.h>
#include <Traps.h>
#include <NumberFormatting.h>
#include <Dialogs.h>
#include <LowMem.h>
#include <Gestalt.h>
#include <Debugging.h>

#if !TARGET_CPU_68K
# error Only 68020+ version supplied.
#endif

// these selectors are private
#pragma parameter __A0 XDBInitialize()
extern Ptr XDBInitialize(void) = {0x70FC, 0xABDB};

#pragma parameter __A0 XDBCleanUp()
extern Ptr XDBCleanUp(void) = {0x70FB, 0xABDB};

typedef struct num_print_format
{
	// automatically expanded if start_digit is non-positive
	// unsigned if negative_symbol is zero
	SInt8			start_digit;
	unsigned char	negative_symbol, *base_symbol;
} num_print_form, num_print_format;


typedef void (*InitCaller)(OSType);

UInt8			empty[16] = "\p";
char			temporary[514];

UInt8				decimal_table[] = "\p0123456789";
UInt8				hexadecimal_table[] = "\p0123456789ABCDEF";
num_print_form		standard_decimal = {0,'-',decimal_table};
num_print_form		standard_unsigned_decimal = {0,'\0',decimal_table};
num_print_form		standard_hexadecimal = {-8,'\0',hexadecimal_table};

void PStrNumBasePrint(Str255 out_str, num_print_form *format, long int value);
void report_error(ConstStr255Param str, short x);

main()
{
	FSSpec			file = {0,0,"\p\x7FXDB Tools"};

	UniversalProcPtr	unimp_trap = GetToolTrapAddress(_Unimplemented);
		/* the older one is _SetRectRgn? */
	UniversalProcPtr	setrectrgn = GetToolTrapAddress(_SetRecRgn);

	Handle			h, *xdb_trap;
	long			size, toolbox;
	short			current_refnum = CurResFile(), refnum, err;

	if ((err=Gestalt(gestaltToolboxTable,&toolbox))!=noErr)
		{report_error("\pGestalt returned an error for toolbox table.",err); goto end;}
	if ((err=FindFolder(kOnSystemDisk,kExtensionFolderType,true,&file.vRefNum,&file.parID))!=noErr)
		{report_error("\pCould not access/generate extensions folder.",err); goto end;}
	SetResLoad(false);
	refnum = FSpOpenResFile(&file,fsRdPerm);
	err = ResError();
	SetResLoad(true);
	if (err<0 || refnum<=0)
		{report_error("\pError attempting to open XDB Tools.",err); goto end;}
	UseResFile(refnum);
	SetResLoad(false);
	h = GetResource('XPTC',0);
	err = ResError();
	SetResLoad(true);
	if (h!=NULL && err>=0)
	{
SafeDebugger();
		if (unimp_trap!=GetToolTrapAddress(0xABDB))
			if ((xdb_trap=(Handle*)XDBCleanUp())!=NULL)
			{
				--xdb_trap;
				if ((setrectrgn=(UniversalProcPtr)*xdb_trap)!=NULL
						&& (Ptr)setrectrgn>LMGetROMBase())
					*(UniversalProcPtr*)(toolbox+(_SetRecRgn&0x3FF)*4) = setrectrgn;
				DisposePtr((Ptr)xdb_trap);
			}
		if ((size=GetResourceSizeOnDisk(h))>0)
		{
		// we are in a process application heap; traps must be set manually
			xdb_trap = (Handle*)NewPtrSys(size+8);
			*xdb_trap++ = (Handle)setrectrgn;	*xdb_trap++ = (Handle)0x68F168F1;
			ReadPartialResource(h,0,xdb_trap,size);
			if ((err=ResError())!=noErr)
			{
				DisposePtr((Ptr)(xdb_trap-=2));
				report_error("\pError reading XPTC resource.",ResError());
			} else
			{
				*(Handle**)(toolbox+(0xABDB&0x3FF)*4) = xdb_trap;
				if ((xdb_trap=(Handle*)XDBInitialize())!=NULL
						&& (Ptr)setrectrgn>LMGetROMBase())
					*(Handle**)(toolbox+(_SetRecRgn&0x3FF)*4) = xdb_trap;
			}
		}
		ReleaseResource(h);
	} else
		report_error("\pError attempting to load XPTC resource.",ResError());
	UseResFile(current_refnum);
	CloseResFile(refnum);
end:
	return 0;
}

void report_error(ConstStr255Param str, short err)
{
	Str63		nstr;

	PStrNumBasePrint(nstr,&standard_decimal,err);
	ParamText(str,nstr,empty,empty);
	Alert(128,NULL);
	ParamText(empty,empty,empty,empty);
}

void PStrNumBasePrint(Str255 out_str, num_print_form *format, long int _value)
{
	unsigned long int	value;
	unsigned long		base, low = (unsigned long)out_str;
	int					start, length;
	UInt8				*digit = out_str+1;

	out_str[0] = 0, low += 2;
	if ((base=format->base_symbol[0])<=1)
		return;	//base = 8;	// octal by default
	if (!format->negative_symbol || _value>=0)
		value = _value, --low;
	else
		value = -_value, *digit++ = format->negative_symbol;
	if ((start=format->start_digit)<=0)
	{
		unsigned long int	temp = value;

		do ++digit; while(temp/=base);
		if (((long)digit-low)<=(start=-start))
			digit = (UInt8*)low+1+start;
	} else
		digit += start;
	out_str[0] = length = (long)digit-(long)out_str-1;

	while((unsigned long)digit>low)
		*--digit = format->base_symbol[(value%base)+1], value /= base;
}
